/**
Data Structures - Taylor
Pointer source, day 1
**/

#include <iostream>
using std::cout;
using std::endl;

int main()
{
  cout << "Address of operator, &" << endl;
  int genePos = 435;
  cout << &genePos << endl << endl;

  cout << "Pointer intitialization" << endl;
  int *p1 = &genePos;
  cout << p1 << endl << endl;

  cout << "Contents-of operator" << endl;
  cout << *p1 << endl;
  int x = *p1;
  cout << x << endl << endl;

  cout << "Contents-of operator assignment" << endl;
  *p1 = 248;
  cout << *p1 << endl << endl;

  cout << "Pointer to a pointer to an int" << endl;
  int **metaP = &p1;
  cout << metaP << endl;
  cout << *metaP << endl;
  cout << **metaP << endl << endl;

  cout << "Operations cancel out" << endl;
  cout << &*p1 << endl;
  cout << *&p1 << endl;
  cout << &*&*p1 << endl;
  cout << *&*&p1 << endl << endl;

  cout << "Pointers and arrays" << endl;
  int a[6] = {1, 7, 3, 4, 2, 8};
  cout << a[2] << endl;
  cout << a << endl;
  cout << *a << endl << endl;

  cout << "Acessing arrays with pointer syntax" << endl;
  // a [offset of 5] = 0
  a[5] = 0;
  cout << a[5] << endl;
  cout << *(a + 5) << endl << endl;

  cout << "Assigning to arrays with pointer syntax" << endl;
  // a [offset of 5] = 1
  *(a + 5) = 1;
  cout << a[5] << endl;
  cout << *(a + 5) << endl << endl;

  cout << "Pointer arithmetic" << endl;
  int *pa = a;
  cout << pa + 2 << endl; // 0x7ffcb158c148
  cout << *(pa + 2) << endl; // 3
  cout << pa++ << endl; // 0x7ffcb158c144
  cout << *pa << endl << endl; // 7

  cout << "Pointer and array arithmetic" << endl;
  cout << pa + 2 << endl; // 0x7ffcb158c148
  cout << a + 2 << endl; // 0x7ffcb158c148

  cout << *(pa + 2) << endl; // 3
  cout << *(a + 2) << endl; // 3

  cout << pa[2] << endl; // 3
  cout << a[2] << endl; // 3

  cout << pa++ << endl; // 0x7ffcb158c144
  //cout << a++ << endl; // not valid, array const

  cout << *pa << endl; // 7
  cout << *a << endl << endl; // 1

  cout << "sizeof(type)" << endl;
  cout << sizeof(char) << endl;
  cout << sizeof(short) << endl;
  cout << sizeof(int) << endl;
  cout << sizeof(double) << endl;
  cout << sizeof(long double) << endl << endl;

  cout << "How to check an array's size?" << endl;
  int arraysize[3]{1, 2, 3};
  cout << sizeof(arraysize) / sizeof(arraysize[0]) << endl << endl;
  // This only works before you pass the array to a function, but not within the function (this is the other way in which arrays are not like pointers)

  cout << "Operator precedence with pointers: use your ()" << endl;
  int genePosArray[3] = {435, 123, 987};
  int *p = genePosArray;
  cout << p << endl; // 0x7ffe35b36ee0
  cout << *(p++) << p << endl; // 435 0x7ffe35b36ee4

  p = genePosArray;
  cout << *p++ << p <<  endl; // 435 0x7ffe35b36ee4

  p = genePosArray;
  cout << *(++p) << p <<  endl; // 123 0x7ffe35b36ee4

  p = genePosArray;
  cout << *++p << p <<  endl; // 123 0x7ffe35b36ee4

  p = genePosArray;
  cout << ++(*p) << p <<  endl; // 436 x7ffe35b36ee0

  p = genePosArray;
  cout << ++*p << p <<  endl; // 437 x7ffe35b36ee0

  p = genePosArray;
  cout << (*p)++ << p <<  endl; // 437 x7ffe35b36ee0

  return 0;
}

